%# BEGIN BPS TAGGED BLOCK {{{
%#
%# COPYRIGHT:
%#
%# This software is Copyright (c) 1996-2016 Best Practical Solutions, LLC
%#                                          <sales@bestpractical.com>
%#
%# (Except where explicitly superseded by other copyright notices)
%#
%#
%# LICENSE:
%#
%# This work is made available to you under the terms of Version 2 of
%# the GNU General Public License. A copy of that license should have
%# been provided with this software, but in any event can be snarfed
%# from www.gnu.org.
%#
%# This work is distributed in the hope that it will be useful, but
%# WITHOUT ANY WARRANTY; without even the implied warranty of
%# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%# General Public License for more details.
%#
%# You should have received a copy of the GNU General Public License
%# along with this program; if not, write to the Free Software
%# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
%# 02110-1301 or visit their web page on the internet at
%# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html.
%#
%#
%# CONTRIBUTION SUBMISSION POLICY:
%#
%# (The following paragraph is not intended to limit the rights granted
%# to you to modify and distribute this software under the terms of
%# the GNU General Public License and is only of importance to you if
%# you choose to contribute your changes and enhancements to the
%# community by submitting them to Best Practical Solutions, LLC.)
%#
%# By intentionally submitting any modifications, corrections or
%# derivatives to this work, or any other work intended for use with
%# Request Tracker, to Best Practical Solutions, LLC, you confirm that
%# you are the copyright holder for those contributions and you grant
%# Best Practical Solutions,  LLC a nonexclusive, worldwide, irrevocable,
%# royalty-free, perpetual, license to use, copy, create derivative
%# works based on those contributions, and sublicense and distribute
%# those contributions and any derivatives thereof.
%#
%# END BPS TAGGED BLOCK }}}
<& Elements/Header, Title => loc("Create a ticket in [_1]", $m->scomp("/Ticket/Elements/ShowQueue", QueueObj => $queue_obj)) &>

<& /Elements/ListActions, actions => \@results &>
<form action="Create.html" method="post" enctype="multipart/form-data" name="TicketCreate">
<input type="hidden" class="hidden" name="id" value="new" />
<input type="hidden" class="hidden" name="Token" value="<% $ARGS{'Token'} %>" />
% for my $key (grep {defined $ARGS{$_}} map {+("new-$_", "$_-new")} keys %RT::Link::DIRMAP) {
<input type="hidden" class="hidden" name="<% $key %>" value="<% $ARGS{$key} %>" />
% }

<table width="100%">
<tr>
<td class="label">
<&|/l&>Queue</&>:
</td>
<td class="value">
    <input type="hidden" class="hidden" name="Queue" value="<%$queue_obj->id || ''%>" />
    <strong><%$queue_obj->Name || ''%></strong> <% $queue_obj->Description ? '('.$queue_obj->Description.')' : '' %>
</td>
</tr>
<% $m->callback( CallbackName => 'AfterQueue', %ARGS, QueueObj => $queue_obj ) %>
<tr>
<td class="label">
<&|/l&>Requestors</&>:
</td>
<td class="value">
<& /Elements/EmailInput, Name => 'Requestors', Size => '20', Default => $ARGS{Requestors} || $session{CurrentUser}->EmailAddress, AutocompleteMultiple => 1 &>
</td>
</tr>
<tr>
<td class="label">
<&|/l&>Cc</&>:
</td>
<td class="value">
<& /Elements/EmailInput, Name => 'Cc', Size => '20', Default => $ARGS{Cc} || '', AutocompleteMultiple => 1 &>
</td>
</tr>
<tr>
<td class="label">
<&|/l&>Subject</&>:
</td>
<td class="value">
<input name="Subject" size="60" maxsize="200" value="<%$ARGS{Subject} || ''%>" />
</td>
</tr>
<tr>
    <td colspan="2">
        <& /Elements/EditCustomFields,
            %ARGS,
            Object          => RT::Ticket->new($session{CurrentUser}),
            CustomFields    => $queue_obj->TicketCustomFields,
            AsTable         => 0,
            &>
    </td>
</tr>
<& /Ticket/Elements/AddAttachments, %ARGS, QueueObj => $queue_obj &>
</table>
<table width="100%">
<tr>
<td colspan="2">
<&|/l&>Describe the issue below</&>:<br />
<& /Elements/MessageBox, Default => $ARGS{Content} || ''  &>
</td>
</tr>
</table>
<& /Elements/Submit, Label => loc("Create ticket")&>


</form>
<%args>
$Queue => undef
</%args>
<%init>
my @results;
my $queue_obj = RT::Queue->new($session{'CurrentUser'});
$queue_obj->Load($Queue);

ProcessAttachments(ARGSRef => \%ARGS);

my $skip_create = 0;

{
    my ($status, @msg) = $m->comp(
        '/Elements/ValidateCustomFields',
        CustomFields => $queue_obj->TicketCustomFields,
        ARGSRef => \%ARGS
    );
    unless ($status) {
        push @results, @msg;
        $skip_create = 1;
    }
}

$m->callback( CallbackName => 'BeforeCreate', ARGSRef => \%ARGS, skip_create => \$skip_create, results => \@results );

if ( !exists $ARGS{'AddMoreAttach'} and defined($ARGS{'id'}) and $ARGS{'id'} eq 'new' ) { # new ticket?
    if ( !$skip_create ) {
        $m->comp('Display.html', %ARGS);
        $RT::Logger->crit("After display call; error is $@");
        $m->abort();
    }
}

</%init>
